/*******************************************************************************
 * FoxSettingsUIVideo generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxSettingsUIVideo extends FoxSettingsUIBase within FoxMenuUI
    native(UI)
    config(UI);

const TesselationMinValue = 2100;
const TesselationMaxValue = 100;
const MaxTesselationLevels = 5;

enum EVideoSettings
{
    VS_Resolution,
    VS_WindowMode,
    VS_LetterBox,
    VS_VSync,
    VS_Gamma,
    VS_WorldDetail,
    VS_CharacterDetail,
    VS_ParticleDetail,
    VS_DynamicLights,
    VS_DynamicShadows,
    VS_Bloom,
    VS_AllowMotionBlur,
    VS_DOFType,
    VS_ZoomBlur,
    VS_DecalCullDistance,
    VS_StaticDecals,
    VS_DynamicDecals,
    VS_FogVolumes,
    VS_Distortion,
    VS_AllowAmbientOcclusion,
    VS_AllowLensFlare,
    VS_AllowPostProcessMLAA,
    VS_AllowLightShafts,
    VS_SmoothFrameRate,
    VS_ScreenDoorFade,
    VS_AllowRain,
    VS_TexturePoolSize,
    VS_AllowDirectX,
    VS_Tesselation,
    VS_ImageReflections,
    VS_TextureQuality,
    VS_MAX
};

enum EAspectRatio
{
    EAR_16x10,
    EAR_16x9,
    EAR_4x3,
    EAR_MAX
};

enum EScreenMode
{
    SCREENMODE_FULL,
    SCREENMODE_WINDOWED,
    SCREENMODE_BORDERLESS,
    SCREENMODE_MAX
};

enum EVideoSettingState
{
    EVSS_NormalSettings,
    EVSS_AdvancedSettings,
    EVSS_MAX
};

struct native VideoSettingResolution
{
    var Vector2D Resolution;
    var FoxSettingsUIVideo.EAspectRatio AspectRatio;

    structdefaultproperties
    {
        Resolution=(X=0.0,Y=0.0)
        AspectRatio=EAspectRatio.EAR_16x10
    }
};

var int TesselationLevelValues[5];
var transient FoxSettingsUIVideo.EAspectRatio CurrentAspectRatio;
var FoxSettingsUIVideo.EVideoSettingState CurrentSettingsState;
var transient array<VideoSettingResolution> SupportedResolutions;
var transient int CurrentResIndex;
var transient bool bIsDX11;
var transient bool bCloseAfterApply;
var const int SaveDialogTime;
var transient int DialogTime;
var const config ButtonContainerWidget AdvancedContainerProperties;
var const config ButtonContainerWidget DX11ContainerProperties;
var const config Vector AdvancedDividerPos;
var const config Vector DX11DividerPos;
var array<string> SupportedResolutionStrings;
var array<string> DataArrayMinThroughMax;
var array<string> LowMediumHighStrings;
var array<string> WindowedStrings;
var array<string> TesselationStrings;
var array<string> DepthOfFieldStrings;

function Initialize()
{
    ProfileSettings = Outer.Outer.PCOwner.ProfileSettings;
    SetupStrings();
    SetupSettingsScene();
    NumSettings = 31;
    OriginalVals.Length = NumSettings;
    CurrentVals.Length = NumSettings;
    DefaultVals.Length = NumSettings;
    GetOriginalVals();
    GetDefaultVals();
    Outer.Outer.Advance(0.0);
    ei_RevertChanges();
    SetupButtonContainer();
    ConfirmSettingsValidity();
    //return;    
}

function SetupSettingsScene()
{
    bIsDX11 = class'Engine'.static.IsUsingDX11();
    CalculateAspectRatio();
    GetSupportedResolutions(,,, CurrentResIndex);
    DataArrayMinThroughMax.AddItem(Outer.LocalizeMenuString("Minimum"));
    DataArrayMinThroughMax.AddItem(Outer.LocalizeMenuString("Low"));
    DataArrayMinThroughMax.AddItem(Outer.LocalizeMenuString("Medium"));
    DataArrayMinThroughMax.AddItem(Outer.LocalizeMenuString("High"));
    DataArrayMinThroughMax.AddItem(Outer.LocalizeMenuString("Maximum"));
    LowMediumHighStrings.AddItem(Outer.LocalizeMenuString("Low"));
    LowMediumHighStrings.AddItem(Outer.LocalizeMenuString("Medium"));
    LowMediumHighStrings.AddItem(Outer.LocalizeMenuString("High"));
    WindowedStrings.AddItem(Outer.LocalizeMenuString("FullScreen"));
    WindowedStrings.AddItem(Outer.LocalizeMenuString("Windowed"));
    WindowedStrings.AddItem(Outer.LocalizeMenuString("Borderless"));
    TesselationStrings.AddItem(Outer.LocalizeMenuString("Disabled"));
    TesselationStrings.AddItem(Outer.LocalizeMenuString("Low"));
    TesselationStrings.AddItem(Outer.LocalizeMenuString("Medium"));
    TesselationStrings.AddItem(Outer.LocalizeMenuString("High"));
    TesselationStrings.AddItem(Outer.LocalizeMenuString("Maximum"));
    DepthOfFieldStrings.AddItem(Outer.LocalizeMenuString("Off"));
    DepthOfFieldStrings.AddItem(Outer.LocalizeMenuString("Standard"));
    DepthOfFieldStrings.AddItem(Outer.LocalizeMenuString("BokehFast"));
    SupportedResolutionStrings = BuildResStrings();
    Outer.as_addAdditionalButtonContainer("container", int(SettingsContainerProperties.X), int(SettingsContainerProperties.Y), 0, 0, 0, 100, "", "", SettingsContainerProperties.WidgetSpacing, SettingsContainerProperties.MaxListWidth, SettingsContainerProperties.MaxListHeight, true);
    as_addSettingsBG(0, 0);
    Outer.Outer.GetVariableObject(Outer.as_addOptionSwitcher(Outer.LocalizeMenuString("Normal"), Outer.LocalizeMenuString("Advanced"), 0, "ei_SettingsModeChanged"), class'FoxSettingsWidget');
    Outer.as_addAdditionalButtonContainer("Video", int(SettingsDividerContainerProperties.X), int(SettingsDividerContainerProperties.Y), 0, 0, 0, 100, "", "", SettingsDividerContainerProperties.WidgetSpacing, SettingsDividerContainerProperties.MaxListWidth, SettingsDividerContainerProperties.MaxListHeight, false);
    AddDefaultSettings();
    //return;    
}

// Export UFoxSettingsUIVideo::execGetSupportedResolutions(FFrame&, void* const)
native function GetSupportedResolutions(optional int OurResX, optional int OurResY, optional out int NewCurrentResIndex);

event array<string> BuildResStrings()
{
    local int I;
    local string ResString;
    local array<string> Result;

    I = 0;
    J0x0B:
    // End:0x18B [Loop If]
    if(I < SupportedResolutions.Length)
    {
        ResString = (string(int(SupportedResolutions[I].Resolution.X)) @ "x") @ string(int(SupportedResolutions[I].Resolution.Y));
        // End:0x167
        if(I != CurrentResIndex)
        {
            switch(SupportedResolutions[I].AspectRatio)
            {
                // End:0x11B
                case 0:
                    ResString = ResString @ "(16:10)";
                    // End:0x167
                    break;
                // End:0x140
                case 1:
                    ResString = ResString @ "(16:9)";
                    // End:0x167
                    break;
                // End:0x164
                case 2:
                    ResString = ResString @ "(4:3)";
                    // End:0x167
                    break;
                // End:0xFFFF
                default:
                }
                Result.AddItem(ResString);
                ++ I;
                // [Loop Continue]
                goto J0x0B;
            }
            return Result;
            //return ReturnValue;            
}

// Export UFoxSettingsUIVideo::execCalculateAspectRatio(FFrame&, void* const)
native function CalculateAspectRatio();

function int GetCurrentAspectRatioIndex()
{
    //return ReturnValue;    
}

function ei_GammaChanged(string NewValueString)
{
    CurrentVals[4] = float(int(NewValueString));
    Outer.Outer.PCOwner.SetGamma((float(NewValueString) / float(50)) + float(1));
    //return;    
}

function ei_SettingsModeChanged(string NewValueString)
{
    local int NewSettings;

    Outer.as_ClearSettings(2);
    NewSettings = int(NewValueString);
    SettingsWidgets.Length = 0;
    // End:0xA3
    if(NewSettings == 0)
    {
        AddDefaultSettings(2);
        Outer.Outer.Advance(0.0);
        UpdateSettings();
    }
    // End:0x101
    else
    {
        // End:0x101
        if(NewSettings == 1)
        {
            AddAdvancedSettings(2);
            Outer.Outer.Advance(0.0);
            UpdateSettings();
        }
    }
    //return;    
}

function ei_ResetToDefaults()
{
    local int I, SettingIndex;

    I = 0;
    J0x0B:
    // End:0xDF [Loop If]
    if(I < SettingsWidgets.Length)
    {
        SettingIndex = int(SettingsWidgets[I].GetString("extClickInterfaceArg"));
        CurrentVals[SettingIndex] = DefaultVals[SettingIndex];
        SettingsWidgets[I].as_SetValue(DefaultVals[SettingIndex]);
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function UpdateSettings()
{
    local int I, SettingIndex;

    I = 0;
    J0x0B:
    // End:0xB8 [Loop If]
    if(I < SettingsWidgets.Length)
    {
        SettingIndex = int(SettingsWidgets[I].GetString("extClickInterfaceArg"));
        SettingsWidgets[I].as_SetValue(OriginalVals[SettingIndex]);
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function AddDefaultSettings(optional int AddToPanel)
{
    AddToPanel = 1;
    CurrentSettingsState = 0;
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("Resolution"), Outer.LocalizeMenuString("ResolutionToolTip"), SupportedResolutionStrings, 0, "ei_SettingChanged", string(0),, AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("WindowMode"), Outer.LocalizeMenuString("WindowModeToolTip"), WindowedStrings, 0, "ei_SettingChanged", string(1),, AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("LetterBox"), Outer.LocalizeMenuString("LetterBoxToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(2), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("VSync"), Outer.LocalizeMenuString("VSyncToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(3), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addSlider(Outer.LocalizeMenuString("Brightness"), Outer.LocalizeMenuString("BrightnessToolTip"), 0.0, 100.0, 1.0, 0.0, "ei_GammaChanged", string(4), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("WorldDetail"), Outer.LocalizeMenuString("WorldDetailToolTip"), LowMediumHighStrings, 0, "ei_SettingChanged", string(5),, AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("CharacterDetail"), Outer.LocalizeMenuString("CharacterDetailToolTip"), LowMediumHighStrings, 0, "ei_SettingChanged", string(6),, AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("ParticleDetail"), Outer.LocalizeMenuString("ParticleDetailToolTip"), LowMediumHighStrings, 0, "ei_SettingChanged", string(7),, AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("DynamicLights"), Outer.LocalizeMenuString("DynamicLightsToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(8), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("DynamicShadows"), Outer.LocalizeMenuString("DynamicShadowsToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(9), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("Bloom"), Outer.LocalizeMenuString("BloomToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(10), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("MotionBlur"), Outer.LocalizeMenuString("MotionBlurToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(11), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("DepthOfField"), Outer.LocalizeMenuString("DepthOfFieldToolTip"), DepthOfFieldStrings, 0, "ei_SettingChanged", string(12),, AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("ZoomBlur"), Outer.LocalizeMenuString("ZoomBlurToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(13), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("Distortion"), Outer.LocalizeMenuString("DistortionToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(18), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("LensFlare"), Outer.LocalizeMenuString("LensFlareToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(20), AddToPanel), class'FoxSettingsWidget')));
    //return;    
}

function AddAdvancedSettings(optional int AddToPanel)
{
    AddToPanel = 1;
    CurrentSettingsState = 1;
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addSlider(Outer.LocalizeMenuString("DecalCullScale"), Outer.LocalizeMenuString("DecalCullScaleToolTip"), 0.50, 3.0, 0.50, 0.0, "ei_DecalCullScaleChanged", string(14), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("StaticDecals"), Outer.LocalizeMenuString("StaticDecalsToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(15), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("DynamicDecals"), Outer.LocalizeMenuString("DynamicDecalsToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(16), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("FogVolumes"), Outer.LocalizeMenuString("FogVolumesToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(17), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("AmbientOcclusion"), Outer.LocalizeMenuString("AmbientOcclusionToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(19), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("PostProcessMLAA"), Outer.LocalizeMenuString("PostProcessMLAAToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(21), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("LightShafts"), Outer.LocalizeMenuString("LightShaftsToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(22), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("FrameRateSmoothing"), Outer.LocalizeMenuString("FramerateSmoothingToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(23), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("ScreenDoorFade"), Outer.LocalizeMenuString("ScreenDoorFadeToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(24), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("AllowRain"), Outer.LocalizeMenuString("AllowRainToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(25), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addSlider(Outer.LocalizeMenuString("TexturePoolSize"), Outer.LocalizeMenuString("TexturePoolSizeToolTip"), 0.50, 2.0, 0.10, 1.0, "ei_TexturePoolSizeChanged", string(26), AddToPanel), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("TextureQuality"), Outer.LocalizeMenuString("TextureQualityTooltip"), DataArrayMinThroughMax, 0, "ei_SettingChanged", string(30),, AddToPanel), class'FoxSettingsWidget')));
    // End:0xE5D
    if(bIsDX11)
    {
        SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("Tesselation"), Outer.LocalizeMenuString("TesselationToolTip"), TesselationStrings, 0, "ei_SettingChanged", string(28),, AddToPanel), class'FoxSettingsWidget')));
        SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addToggleButton(Outer.LocalizeMenuString("ImageReflections"), Outer.LocalizeMenuString("ImageReflectionsToolTip"), EnabledDisabledStrings, 0, "ei_SettingChanged", string(29), AddToPanel), class'FoxSettingsWidget')));
    }
    //return;    
}

function ei_TexturePoolSizeChanged(string NewValueString)
{
    CurrentVals[26] = float(NewValueString);
    //return;    
}

function ei_DecalCullScaleChanged(string NewValueString)
{
    CurrentVals[14] = float(int(NewValueString));
    //return;    
}

event int TesselationLevelToScale(int Level)
{
    local int Retval;

    Retval = TesselationLevelValues[Level];
    return Retval;
    //return ReturnValue;    
}

event int TesselationScaleToLevel(int Scale)
{
    local int Retval, I;

    I = 0;
    J0x0B:
    // End:0x60 [Loop If]
    if(I < 5)
    {
        // End:0x52
        if(Scale >= TesselationLevelValues[I])
        {
            Retval = I;
            // [Explicit Break]
            goto J0x60;
        }
        ++ I;
        J0x60:
        // [Loop Continue]
        goto J0x0B;
    }
    return Retval;
    //return ReturnValue;    
}

function TryClose(class<FoxSettingsUIBase> TheNextSettingsClass)
{
    NextSettingsClass = TheNextSettingsClass;
    // End:0x2D
    if(HasSettingsChanged())
    {
        LaunchApplyDialog();
    }
    // End:0x40
    else
    {
        super.TryClose(TheNextSettingsClass);
    }
    //return;    
}

function LaunchApplyDialog()
{
    local DialogBoxProperties newProperties;

    newProperties.DialogType = 2;
    newProperties.TitleText = Outer.LocalizeMenuString("ApplyChangesTitle", SettingsLocalizationSectionName);
    newProperties.BodyText = Outer.LocalizeMenuString("ApplyChangesMessage", SettingsLocalizationSectionName);
    newProperties.bShowTimer = false;
    newProperties.bCloseOnButtonPress = false;
    newProperties.OnDialogButtonPressed = OnApplySettingsClose;
    Outer.Outer.ShowDialogBox(newProperties);
    //return;    
}

function OnApplySettingsClose(FoxDialogBoxBase.EDialogBoxConfirmType Selection)
{
    // End:0x2C
    if(Selection == 0)
    {
        ApplyChanges();
        LaunchSaveDialog(true);
    }
    // End:0x4C
    else
    {
        ei_RevertChanges(true);
        ApplyChanges();
        BeginClose();
    }
    //return;    
}

function LaunchSaveDialog(bool bExitOnClose)
{
    local DialogBoxProperties newProperties;

    DialogTime = SaveDialogTime;
    bCloseAfterApply = bExitOnClose;
    Outer.Outer.PCOwner.SetTimer(1.0, true, 'OnTimerTick', self);
    newProperties.DialogType = 2;
    newProperties.TitleText = Outer.LocalizeMenuString("SettingsChangedTitle", SettingsLocalizationSectionName);
    newProperties.BodyText = Outer.LocalizeMenuString("SettingsChangedMessage", SettingsLocalizationSectionName) @ string(DialogTime);
    newProperties.bShowTimer = false;
    newProperties.bCloseOnButtonPress = false;
    newProperties.OnDialogButtonPressed = OnSaveSettingsClose;
    Outer.Outer.ShowDialogBox(newProperties);
    //return;    
}

function OnSaveSettingsClose(FoxDialogBoxBase.EDialogBoxConfirmType Selection)
{
    Outer.Outer.PCOwner.ClearTimer('OnTimerTick', self);
    // End:0x95
    if(Selection == 0)
    {
        Outer.bRequiresProfileSave = true;
        SaveChanges();
    }
    // End:0xB3
    else
    {
        ei_RevertChanges(bCloseAfterApply);
        ApplyChanges();
    }
    Outer.Outer.CloseDialogBox();
    // End:0xFF
    if(bCloseAfterApply)
    {
        BeginClose();
    }
    //return;    
}

function OnSettingsClose()
{
    Outer.Outer.PCOwner.ClearTimer('OnTimerTick', self);
    //return;    
}

function OnTimerTick()
{
    DialogTime -= 1;
    // End:0x2A
    if(DialogTime == 0)
    {
        OnSaveSettingsClose(1);
    }
    // End:0x102
    else
    {
        // End:0x102
        if(Outer.Outer.DialogBox != none)
        {
            FoxDialogBox(Outer.Outer.DialogBox).SetBodyText(Outer.LocalizeMenuString("SettingsChangedMessage", SettingsLocalizationSectionName) @ string(DialogTime));
        }
    }
    //return;    
}

// Export UFoxSettingsUIVideo::execGetOriginalVals(FFrame&, void* const)
native function GetOriginalVals();

// Export UFoxSettingsUIVideo::execGetDefaultVals(FFrame&, void* const)
native function GetDefaultVals();

// Export UFoxSettingsUIVideo::execApplyChanges(FFrame&, void* const)
native function ApplyChanges();

function ei_ApplyChanges()
{
    // End:0x22
    if(HasSettingsChanged())
    {
        ApplyChanges();
        LaunchSaveDialog(false);
    }
    //return;    
}

function OnLostFocusPause(bool bEnable)
{
    // End:0xB3
    if(Outer.Outer.PCOwner.IsTimerActive('OnTimerTick', self))
    {
        Outer.Outer.PCOwner.PauseTimer(bEnable, 'OnTimerTick', self);
    }
    //return;    
}

defaultproperties
{
    TesselationLevelValues[0]=10000
    TesselationLevelValues[1]=800
    TesselationLevelValues[2]=400
    TesselationLevelValues[3]=200
    TesselationLevelValues[4]=48
    SaveDialogTime=10
    SettingsDividerContainerProperties=(Y=-165.0,MaxListWidth=800)
}